using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Reflection;
using System.Windows.Forms;

namespace TexturePicker
{
	/// <summary>
	/// Summary description for AboutDialog.
	/// </summary>
	public class AboutDialog : TexturePicker.MoveAnywhereForm
	{
		/************************************************
		 * Constants
		 ***********************************************/
		private const string homeURL = "http://www.solersoft.com/texturepicker";
		/************************************************
		 * Designer Variables
		 ***********************************************/
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.FolderBrowserDialog folderBrowser;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Label lblCredits;
		private System.Windows.Forms.LinkLabel lblHome;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/************************************************
		 * Constructors
		 ***********************************************/
		public AboutDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutDialog));
			this.folderBrowser = new System.Windows.Forms.FolderBrowserDialog();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.lblVersion = new System.Windows.Forms.Label();
			this.lblCredits = new System.Windows.Forms.Label();
			this.lblHome = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(400, 80);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 6;
			this.pictureBox1.TabStop = false;
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(312, 272);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 6;
			this.btnOK.Text = "OK";
			// 
			// lblVersion
			// 
			this.lblVersion.AutoSize = true;
			this.lblVersion.ForeColor = System.Drawing.SystemColors.GrayText;
			this.lblVersion.Location = new System.Drawing.Point(8, 280);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(80, 16);
			this.lblVersion.TabIndex = 8;
			this.lblVersion.Text = "Version 1.0.0.0";
			// 
			// lblCredits
			// 
			this.lblCredits.Location = new System.Drawing.Point(8, 92);
			this.lblCredits.Name = "lblCredits";
			this.lblCredits.Size = new System.Drawing.Size(380, 128);
			this.lblCredits.TabIndex = 9;
			this.lblCredits.Text = "Credits";
			// 
			// lblHome
			// 
			this.lblHome.AutoSize = true;
			this.lblHome.Location = new System.Drawing.Point(100, 280);
			this.lblHome.Name = "lblHome";
			this.lblHome.Size = new System.Drawing.Size(34, 16);
			this.lblHome.TabIndex = 10;
			this.lblHome.TabStop = true;
			this.lblHome.Text = "Home";
			this.lblHome.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.lblHome_LinkClicked);
			// 
			// AboutDialog
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(394, 302);
			this.Controls.Add(this.lblHome);
			this.Controls.Add(this.lblVersion);
			this.Controls.Add(this.lblCredits);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.pictureBox1);
			this.Name = "AboutDialog";
			this.ResumeLayout(false);

		}
		#endregion

		/************************************************
		 * Internal Methods
		 ***********************************************/

		/************************************************
		 * Overrides / Event Handlers
		 ***********************************************/		
		protected override void OnLoad(EventArgs e)
		{
			// Pass to base first
			base.OnLoad (e);

			// Show version
			AssemblyName asmName = Assembly.GetExecutingAssembly().GetName();
			lblVersion.Text = string.Format("Version {0}.{1}", asmName.Version.Major, asmName.Version.Minor);

			// Show credits
			string credits = "Original concept and code by eXentric. Some code contributed by SolerSoft.\r\n\r\n";
			credits += "Thanks to Rice for the excellent plugin and thanks to the many talented artists in the community who have made this program worth while.\r\n\r\n";
			credits += "If you modify the source, please submit your changes back to eXentric so they can be hosted on SolerSoft.com. You will be given credit here.";
			lblCredits.Text = credits;

			// Show home
			lblHome.Text = homeURL;
		}

		private void lblHome_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Process.Start(homeURL);
		}

		/************************************************
		 * Properties
		 ***********************************************/
	}
}
