using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace TexturePicker
{
	/// <summary>
	/// Main user interface for the application.
	/// </summary>
	public class MainUI : System.Windows.Forms.Form
	{
		/************************************************
		 * Member Variables
		 ***********************************************/
		private bool ignoreCheckEvents;

		/************************************************
		 * Designer Variables
		 ***********************************************/
		private System.Windows.Forms.ListView lvTextures;
		private System.Windows.Forms.ColumnHeader colName;
		private System.Windows.Forms.Splitter splitV;
		private TexturePicker.TextureView textureView;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.ListView lvSources;
		private System.Windows.Forms.ColumnHeader colSourceSize;
		private System.Windows.Forms.ColumnHeader colSourceFolder;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuFileNewProject;
		private System.Windows.Forms.MenuItem mnuFileSep1;
		private System.Windows.Forms.MenuItem mnuFileExit;
		private System.Windows.Forms.MenuItem mnuHelp;
		private System.Windows.Forms.MenuItem mnuHelpAbout;
		private System.Windows.Forms.MenuItem mnuFileExport;
		private System.Windows.Forms.ColumnHeader colSourceFiles;
		private System.Windows.Forms.ColumnHeader colSourceComponents;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/************************************************
		 * Constructors
		 ***********************************************/
		public MainUI()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainUI));
			this.lvTextures = new System.Windows.Forms.ListView();
			this.colName = new System.Windows.Forms.ColumnHeader();
			this.splitV = new System.Windows.Forms.Splitter();
			this.textureView = new TexturePicker.TextureView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.lvSources = new System.Windows.Forms.ListView();
			this.colSourceFolder = new System.Windows.Forms.ColumnHeader();
			this.colSourceComponents = new System.Windows.Forms.ColumnHeader();
			this.colSourceSize = new System.Windows.Forms.ColumnHeader();
			this.colSourceFiles = new System.Windows.Forms.ColumnHeader();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuFileNewProject = new System.Windows.Forms.MenuItem();
			this.mnuFileExport = new System.Windows.Forms.MenuItem();
			this.mnuFileSep1 = new System.Windows.Forms.MenuItem();
			this.mnuFileExit = new System.Windows.Forms.MenuItem();
			this.mnuHelp = new System.Windows.Forms.MenuItem();
			this.mnuHelpAbout = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// lvTextures
			// 
			this.lvTextures.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.colName});
			this.lvTextures.Dock = System.Windows.Forms.DockStyle.Left;
			this.lvTextures.GridLines = true;
			this.lvTextures.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvTextures.HideSelection = false;
			this.lvTextures.Location = new System.Drawing.Point(0, 0);
			this.lvTextures.MultiSelect = false;
			this.lvTextures.Name = "lvTextures";
			this.lvTextures.Size = new System.Drawing.Size(272, 519);
			this.lvTextures.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.lvTextures.TabIndex = 0;
			this.lvTextures.View = System.Windows.Forms.View.Details;
			this.lvTextures.SelectedIndexChanged += new System.EventHandler(this.lvTextures_SelectedIndexChanged);
			// 
			// colName
			// 
			this.colName.Text = "Name";
			this.colName.Width = 265;
			// 
			// splitV
			// 
			this.splitV.Location = new System.Drawing.Point(272, 0);
			this.splitV.Name = "splitV";
			this.splitV.Size = new System.Drawing.Size(3, 519);
			this.splitV.TabIndex = 1;
			this.splitV.TabStop = false;
			// 
			// textureView
			// 
			this.textureView.Dock = System.Windows.Forms.DockStyle.Top;
			this.textureView.Location = new System.Drawing.Point(275, 0);
			this.textureView.Name = "textureView";
			this.textureView.Size = new System.Drawing.Size(471, 316);
			this.textureView.TabIndex = 2;
			this.textureView.TabStop = false;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(275, 316);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(471, 3);
			this.splitter1.TabIndex = 3;
			this.splitter1.TabStop = false;
			// 
			// lvSources
			// 
			this.lvSources.AllowColumnReorder = true;
			this.lvSources.CheckBoxes = true;
			this.lvSources.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.colSourceFolder,
																						this.colSourceComponents,
																						this.colSourceSize,
																						this.colSourceFiles});
			this.lvSources.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvSources.FullRowSelect = true;
			this.lvSources.GridLines = true;
			this.lvSources.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvSources.HideSelection = false;
			this.lvSources.Location = new System.Drawing.Point(275, 319);
			this.lvSources.MultiSelect = false;
			this.lvSources.Name = "lvSources";
			this.lvSources.Size = new System.Drawing.Size(471, 200);
			this.lvSources.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.lvSources.TabIndex = 1;
			this.lvSources.View = System.Windows.Forms.View.Details;
			this.lvSources.SelectedIndexChanged += new System.EventHandler(this.lvSources_SelectedIndexChanged);
			this.lvSources.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.lvSources_ItemCheck);
			// 
			// colSourceFolder
			// 
			this.colSourceFolder.Text = "Source";
			this.colSourceFolder.Width = 301;
			// 
			// colSourceComponents
			// 
			this.colSourceComponents.Text = "Compon.";
			this.colSourceComponents.Width = 64;
			// 
			// colSourceSize
			// 
			this.colSourceSize.Text = "Size";
			// 
			// colSourceFiles
			// 
			this.colSourceFiles.Text = "Files";
			this.colSourceFiles.Width = 39;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.mnuFile,
																					 this.mnuHelp});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFileNewProject,
																					this.mnuFileExport,
																					this.mnuFileSep1,
																					this.mnuFileExit});
			this.mnuFile.Text = "&File";
			// 
			// mnuFileNewProject
			// 
			this.mnuFileNewProject.Index = 0;
			this.mnuFileNewProject.Text = "&New Project...";
			this.mnuFileNewProject.Click += new System.EventHandler(this.mnuFileNewProject_Click);
			// 
			// mnuFileExport
			// 
			this.mnuFileExport.Index = 1;
			this.mnuFileExport.Text = "&Export Textures";
			this.mnuFileExport.Click += new System.EventHandler(this.mnuFileExport_Click);
			// 
			// mnuFileSep1
			// 
			this.mnuFileSep1.Index = 2;
			this.mnuFileSep1.Text = "-";
			// 
			// mnuFileExit
			// 
			this.mnuFileExit.Index = 3;
			this.mnuFileExit.Text = "E&xit";
			this.mnuFileExit.Click += new System.EventHandler(this.mnuFileExit_Click);
			// 
			// mnuHelp
			// 
			this.mnuHelp.Index = 1;
			this.mnuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuHelpAbout});
			this.mnuHelp.Text = "Help";
			// 
			// mnuHelpAbout
			// 
			this.mnuHelpAbout.Index = 0;
			this.mnuHelpAbout.Text = "About...";
			this.mnuHelpAbout.Click += new System.EventHandler(this.mnuHelpAbout_Click);
			// 
			// MainUI
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(746, 519);
			this.Controls.Add(this.lvSources);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.textureView);
			this.Controls.Add(this.splitV);
			this.Controls.Add(this.lvTextures);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.KeyPreview = true;
			this.Menu = this.mainMenu;
			this.Name = "MainUI";
			this.Text = "Texture Picker";
			this.ResumeLayout(false);

		}
		#endregion

		/************************************************
		 * Internal Methods
		 ***********************************************/
		/// <summary>
		/// Binds the form to the current project.
		/// </summary>
		private void BindToProject()
		{
			BindToTextures();
		}

		/// <summary>
		/// Binds controls on the form to the main texture list.
		/// </summary>
		private void BindToTextures()
		{
			// Hold updates
			lvTextures.BeginUpdate();

			// Clear out existing list
			lvTextures.Items.Clear();

			// Load new items
			foreach (Texture texture in App.Textures)
			{
				// Create item
				ListViewItem textureItem = new ListViewItem(texture.Name);

				// Associate item
				textureItem.Tag = texture;

				// Add item to list
				lvTextures.Items.Add(textureItem);
			}

			// If there is at least one texture, select it
			if (lvTextures.Items.Count > 0)
			{
				lvTextures.Items[0].Selected = true;
			}
			else
			{
				BindToTexture(null);
			}

			// Release updates
			lvTextures.EndUpdate();
		}

		/// <summary>
		/// Binds controls on the form to a specific texture.
		/// </summary>
		/// <param name="texture">
		/// The texture to bind to.
		/// </param>
		private void BindToTexture(Texture texture)
		{
			// Suspend updates
			lvSources.BeginUpdate();

			// Clear existing items
			lvSources.Items.Clear();

			// If texture is not bindable, clear controls. Otherwise, bind controls.
			if (texture == null)
			{
				BindToSource(null);
			}
			else
			{
				// Load sources
				foreach (Source source in texture.Sources)
				{
					// Create a list item
					ListViewItem sourceItem = new ListViewItem(new string[] {source.Name, null, null, null});

					// Display components
					sourceItem.SubItems[1].Text = source.Components.ToString();

					// Get size
					double kSize = 0;
					foreach (FileInfo file in source.AssociatedFiles)
					{
						kSize += file.Length;
					}
					kSize = kSize / 1024d;

					// Display size
					sourceItem.SubItems[2].Text = string.Format("{0}k", kSize.ToString("0.00"));

					// Display file count
					sourceItem.SubItems[3].Text = source.AssociatedFiles.Count.ToString();

					// Checked?
					if (texture.SelectedSource == source)
					{
						sourceItem.Checked = true;
						sourceItem.Selected = true;
					}

					// Associate item
					sourceItem.Tag = source;

					// Add item
					lvSources.Items.Add(sourceItem);
				}

				// If no item was selected, clear the details out
				if (lvSources.Items.Count < 1)
				{
					BindToSource(null);
				}
			}

			// Release updates
			lvSources.EndUpdate();
		}

		/// <summary>
		/// Binds controls on the form to a specific source.
		/// </summary>
		/// <param name="source">
		/// The source to bind to.
		/// </param>
		private void BindToSource(Source source)
		{
			// If texture is not bindable, clear controls. Otherwise, bind controls.
			if (source == null)
			{
				textureView.Image = null;
			}
			else
			{
				// Try to load the image from file
				try
				{
					textureView.Image = Image.FromFile(source.MainFile.FullName);
				}
				catch (Exception ex)
				{
					MessageBox.Show(string.Format("Could not display texture. {0}", ex.Message));
				}
			}
		}

		/************************************************
		 * Overrides / Event Handlers
		 ***********************************************/
		private void lvSources_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Bind to the selected texture (or null if there isn't one selected)
			if (lvSources.SelectedIndices.Count > 0)
			{
				BindToSource((Source)lvSources.Items[lvSources.SelectedIndices[0]].Tag);
			}
			else
			{
				BindToSource(null);
			}
		}

		private void lvSources_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
		{
			// We're going to modify this handler to make the check boxes work like a radio group

			// Check to see if we're already ignoring check events
			if (ignoreCheckEvents) return;

			// Ignore check events while we're in here
			ignoreCheckEvents = true;

			// If item is becomming checked, we have to uncheck all other items
			// We don't allow items to be unchecked
			if (e.NewValue == CheckState.Checked)
			{
				// Uncheck all other items. We can do this foreach because the new item hasn't
				// been added to the 'CheckedItems' collection by the time this event fires.
				foreach (ListViewItem item in lvSources.CheckedItems)
				{
					item.Checked = false;
				}

				// Get the selected texture
				Texture selectedTexture = (Texture)lvTextures.Items[lvTextures.SelectedIndices[0]].Tag;

				// Get the source from the item
				Source selectedSource = (Source)lvSources.Items[e.Index].Tag;

				// Set this source as the selected source
				selectedTexture.SelectedSource = selectedSource;
			}
			else
			{
				// Don't allow uncheck
				e.NewValue = CheckState.Checked;
			}

			// Start listening to check events again
			ignoreCheckEvents = false;
		}

		private void lvTextures_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Bind to the selected texture (or null if there isn't one selected)
			if (lvTextures.SelectedIndices.Count > 0)
			{
				BindToTexture((Texture)lvTextures.Items[lvTextures.SelectedIndices[0]].Tag);
			}
			else
			{
				BindToTexture(null);
			}
		}

		private void mnuFileExit_Click(object sender, System.EventArgs e)
		{
			// Close the window
			Close();
		}

		private void mnuFileNewProject_Click(object sender, System.EventArgs e)
		{
			// Try to create a new project and if successful, bind to it.
			if (App.NewProject()) BindToProject();
		}

		private void mnuHelpAbout_Click(object sender, System.EventArgs e)
		{
			// Create about dialog
			AboutDialog about = new AboutDialog();
			
			// Show dialog
			about.ShowDialog(this);
		}

		private void mnuFileExport_Click(object sender, System.EventArgs e)
		{
			App.ExportTextures();
		}

		protected override void OnKeyDown(KeyEventArgs e)
		{
			// We're only listening if Alt is pressed
			if (e.Alt)
			{
				if (e.KeyCode == Keys.Menu) return;
				System.Diagnostics.Debug.WriteLine(e.KeyCode.ToString());
				if (e.KeyCode == Keys.Left)
				{
					lvTextures.Focus();
					e.Handled = true;
				}
				else if (e.KeyCode == Keys.Right)
				{
					lvSources.Focus();
					e.Handled = true;
				}
			}

			// Pass to base for additional processing
			base.OnKeyDown (e);
		}

		protected override void OnLoad(EventArgs e)
		{
			// Pass to base first
			base.OnLoad (e);
			
			// Bind to the loaded project.
			BindToProject();
		}
	}
}
