using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TexturePicker
{
	/// <summary>
	/// A form that has no title bar, no caption and does not show in the tray but can be easily moved by clicking anywhere in the form body.
	/// </summary>
	public class MoveAnywhereForm : System.Windows.Forms.Form
	{
		/************************************************
		 * Member Variables
		 ***********************************************/
		private Point mouseOffset;

		/************************************************
		 * Designer Variables
		 ***********************************************/
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/************************************************
		 * Constructors
		 ***********************************************/
		public MoveAnywhereForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// MoveAnywhereForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.ControlBox = false;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Name = "MoveAnywhereForm";

		}
		#endregion


		/************************************************
		 * Overrides / Event Handlers
		 ***********************************************/
		protected override void OnMouseDown(MouseEventArgs e)
		{
			// Pass to base first
			base.OnMouseDown (e);

			// Rememver location for movement
			mouseOffset = new Point(-e.X, -e.Y);
		}

		protected override void OnMouseMove(MouseEventArgs e)
		{
			// If the mouse is down, we'll process it. Otherwise, pass it on to the base
			if (e.Button == MouseButtons.Left)
			{
				Point mousePos = Control.MousePosition;
				mousePos.Offset(mouseOffset.X, mouseOffset.Y);
				Location = mousePos;
			}
			else
			{
				base.OnMouseMove(e);
			}
		}
	}
}
