using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Reflection;
using System.Windows.Forms;

namespace TexturePicker
{
	/// <summary>
	/// Summary description for SelectFolders.
	/// </summary>
	public class SelectFolders : TexturePicker.MoveAnywhereForm
	{
		private System.Windows.Forms.Label lblSourceInfo;
		private System.Windows.Forms.TextBox txtSourcePath;
		private System.Windows.Forms.Button btnBrowseSource;
		private System.Windows.Forms.Button btnBrowseTarget;
		private System.Windows.Forms.TextBox txtTargetPath;
		private System.Windows.Forms.Label lblTargetInfo;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.FolderBrowserDialog folderBrowser;
		private System.Windows.Forms.Label lblVersion;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SelectFolders()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SelectFolders));
			this.folderBrowser = new System.Windows.Forms.FolderBrowserDialog();
			this.lblSourceInfo = new System.Windows.Forms.Label();
			this.txtSourcePath = new System.Windows.Forms.TextBox();
			this.btnBrowseSource = new System.Windows.Forms.Button();
			this.btnBrowseTarget = new System.Windows.Forms.Button();
			this.txtTargetPath = new System.Windows.Forms.TextBox();
			this.lblTargetInfo = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.lblVersion = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// lblSourceInfo
			// 
			this.lblSourceInfo.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblSourceInfo.Location = new System.Drawing.Point(4, 88);
			this.lblSourceInfo.Name = "lblSourceInfo";
			this.lblSourceInfo.Size = new System.Drawing.Size(388, 48);
			this.lblSourceInfo.TabIndex = 0;
			this.lblSourceInfo.Text = "Select the folder where source images can be found. This folder will have sub-fol" +
				"ders where you have extracted individual texture packs.";
			// 
			// txtSourcePath
			// 
			this.txtSourcePath.Location = new System.Drawing.Point(4, 144);
			this.txtSourcePath.Name = "txtSourcePath";
			this.txtSourcePath.Size = new System.Drawing.Size(352, 20);
			this.txtSourcePath.TabIndex = 1;
			this.txtSourcePath.Text = "";
			// 
			// btnBrowseSource
			// 
			this.btnBrowseSource.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowseSource.Location = new System.Drawing.Point(364, 144);
			this.btnBrowseSource.Name = "btnBrowseSource";
			this.btnBrowseSource.Size = new System.Drawing.Size(24, 23);
			this.btnBrowseSource.TabIndex = 2;
			this.btnBrowseSource.Text = "...";
			this.btnBrowseSource.Click += new System.EventHandler(this.btnBrowseSource_Click);
			// 
			// btnBrowseTarget
			// 
			this.btnBrowseTarget.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowseTarget.Location = new System.Drawing.Point(363, 240);
			this.btnBrowseTarget.Name = "btnBrowseTarget";
			this.btnBrowseTarget.Size = new System.Drawing.Size(24, 23);
			this.btnBrowseTarget.TabIndex = 5;
			this.btnBrowseTarget.Text = "...";
			this.btnBrowseTarget.Click += new System.EventHandler(this.btnBrowseTarget_Click);
			// 
			// txtTargetPath
			// 
			this.txtTargetPath.Location = new System.Drawing.Point(3, 240);
			this.txtTargetPath.Name = "txtTargetPath";
			this.txtTargetPath.Size = new System.Drawing.Size(352, 20);
			this.txtTargetPath.TabIndex = 4;
			this.txtTargetPath.Text = "";
			// 
			// lblTargetInfo
			// 
			this.lblTargetInfo.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTargetInfo.Location = new System.Drawing.Point(3, 184);
			this.lblTargetInfo.Name = "lblTargetInfo";
			this.lblTargetInfo.Size = new System.Drawing.Size(388, 48);
			this.lblTargetInfo.TabIndex = 3;
			this.lblTargetInfo.Text = "Select the folder where you want selected textures to be output. All images will " +
				"be output directly into this folder, no sub-folders will be created.";
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(400, 80);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 6;
			this.pictureBox1.TabStop = false;
			// 
			// btnOK
			// 
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(228, 272);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 6;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(312, 272);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 7;
			this.btnCancel.Text = "Cancel";
			// 
			// lblVersion
			// 
			this.lblVersion.AutoSize = true;
			this.lblVersion.ForeColor = System.Drawing.SystemColors.GrayText;
			this.lblVersion.Location = new System.Drawing.Point(8, 280);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(80, 16);
			this.lblVersion.TabIndex = 8;
			this.lblVersion.Text = "Version 1.0.0.0";
			// 
			// SelectFolders
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(394, 302);
			this.Controls.Add(this.lblVersion);
			this.Controls.Add(this.txtTargetPath);
			this.Controls.Add(this.txtSourcePath);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.btnBrowseTarget);
			this.Controls.Add(this.lblTargetInfo);
			this.Controls.Add(this.btnBrowseSource);
			this.Controls.Add(this.lblSourceInfo);
			this.Name = "SelectFolders";
			this.ResumeLayout(false);
		}
		#endregion

		/************************************************
		 * Internal Methods
		 ***********************************************/
		private void BrowseForSource()
		{
			// Set the description
			folderBrowser.Description = "Select the folder where source textures can be found.";
			
			// Show the dialog and get the results
			DialogResult result = folderBrowser.ShowDialog(this);

			// If successful, store path
			if (result == DialogResult.OK) txtSourcePath.Text = folderBrowser.SelectedPath;
		}

		private void BrowseForTarget()
		{
			// Set the description
			folderBrowser.Description = "Select the folder where selected textures will be output.";

			// Show the dialog and get the results
			DialogResult result = folderBrowser.ShowDialog(this);

			// If successful, store path
			if (result == DialogResult.OK) txtTargetPath.Text = folderBrowser.SelectedPath;
		}

		private bool ValidatePaths()
		{
			if (SourcePath == string.Empty)
			{
				MessageBox.Show("You must specify a source path.");
				return false;
			}

			if (!Directory.Exists(SourcePath))
			{
				MessageBox.Show("The specified source path does not exist.");
				return false;
			}

			if (TargetPath == string.Empty)
			{
				MessageBox.Show("You must specify a target path.");
				return false;
			}

			if (!Directory.Exists(TargetPath))
			{
				MessageBox.Show("The specified target path does not exist.");
				return false;
			}

			// Success
			return true;
		}

		/************************************************
		 * Overrides / Event Handlers
		 ***********************************************/		
		private void btnBrowseSource_Click(object sender, System.EventArgs e)
		{
			BrowseForSource();
		}

		private void btnBrowseTarget_Click(object sender, System.EventArgs e)
		{
			BrowseForTarget();
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			// If all paths are valid, close dialog with 'OK'
			if (ValidatePaths()) DialogResult = DialogResult.OK;
		}

		protected override void OnLoad(EventArgs e)
		{
			// Pass to base first
			base.OnLoad (e);

			// Show version
			AssemblyName asmName = Assembly.GetExecutingAssembly().GetName();
			lblVersion.Text = string.Format("Version {0}.{1}", asmName.Version.Major, asmName.Version.Minor);
		}

		/************************************************
		 * Properties
		 ***********************************************/
		/// <summary>
		/// Gets or sets the path selected for source files.
		/// </summary>
		public string SourcePath
		{
			get
			{
				return txtSourcePath.Text;
			}
			set
			{
				txtSourcePath.Text = value;
			}
		}

		/// <summary>
		/// Gets or sets the path selected for source files.
		/// </summary>
		public string TargetPath
		{
			get
			{
				return txtTargetPath.Text;
			}
			set
			{
				txtTargetPath.Text = value;
			}
		}
	}
}
