using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace TexturePicker
{
	/// <summary>
	/// Summary description for TextureView.
	/// </summary>
	public class TextureView : System.Windows.Forms.UserControl
	{
		private TexturePicker.ImageView imageView;
		private System.Windows.Forms.TrackBar tbZoom;
		private System.Windows.Forms.CheckBox chkFill;
		private System.Windows.Forms.Label lblZoom;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TextureView()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.imageView = new TexturePicker.ImageView();
			this.chkFill = new System.Windows.Forms.CheckBox();
			this.tbZoom = new System.Windows.Forms.TrackBar();
			this.lblZoom = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.tbZoom)).BeginInit();
			this.SuspendLayout();
			// 
			// imageView
			// 
			this.imageView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.imageView.BackColor = System.Drawing.Color.Black;
			this.imageView.Location = new System.Drawing.Point(0, 0);
			this.imageView.Name = "imageView";
			this.imageView.Size = new System.Drawing.Size(408, 372);
			this.imageView.TabIndex = 3;
			this.imageView.TabStop = false;
			this.imageView.Zoom = 1;
			// 
			// chkFill
			// 
			this.chkFill.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.chkFill.Location = new System.Drawing.Point(4, 376);
			this.chkFill.Name = "chkFill";
			this.chkFill.Size = new System.Drawing.Size(40, 16);
			this.chkFill.TabIndex = 0;
			this.chkFill.Text = "Fill";
			this.chkFill.CheckedChanged += new System.EventHandler(this.chkFill_CheckedChanged);
			// 
			// tbZoom
			// 
			this.tbZoom.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.tbZoom.AutoSize = false;
			this.tbZoom.LargeChange = 100;
			this.tbZoom.Location = new System.Drawing.Point(48, 376);
			this.tbZoom.Maximum = 1000;
			this.tbZoom.Minimum = 10;
			this.tbZoom.Name = "tbZoom";
			this.tbZoom.Size = new System.Drawing.Size(120, 20);
			this.tbZoom.SmallChange = 10;
			this.tbZoom.TabIndex = 1;
			this.tbZoom.TickFrequency = 15;
			this.tbZoom.TickStyle = System.Windows.Forms.TickStyle.None;
			this.tbZoom.Value = 100;
			this.tbZoom.ValueChanged += new System.EventHandler(this.tbZoom_ValueChanged);
			// 
			// lblZoom
			// 
			this.lblZoom.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblZoom.AutoSize = true;
			this.lblZoom.Location = new System.Drawing.Point(172, 376);
			this.lblZoom.Name = "lblZoom";
			this.lblZoom.Size = new System.Drawing.Size(33, 16);
			this.lblZoom.TabIndex = 2;
			this.lblZoom.Text = "100%";
			// 
			// TextureView
			// 
			this.Controls.Add(this.lblZoom);
			this.Controls.Add(this.tbZoom);
			this.Controls.Add(this.chkFill);
			this.Controls.Add(this.imageView);
			this.Name = "TextureView";
			this.Size = new System.Drawing.Size(408, 396);
			((System.ComponentModel.ISupportInitialize)(this.tbZoom)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/************************************************
		 * Overrides / Event Handlers
		 ***********************************************/
		private void chkFill_CheckedChanged(object sender, System.EventArgs e)
		{
			imageView.EnlargeToFill = chkFill.Checked;
			tbZoom.Enabled = !chkFill.Checked;
			lblZoom.Enabled = !chkFill.Checked;
		}

		private void tbZoom_ValueChanged(object sender, System.EventArgs e)
		{
			imageView.Zoom = (double)tbZoom.Value / 100d;
			lblZoom.Text = string.Format("{0}%", tbZoom.Value);
		}

		/************************************************
		 * Properties
		 ***********************************************/
		/// <summary>
		/// Gets or sets the <see cref="Image"/> that the <see cref="TextureView"/> displays.
		/// </summary>
		[DefaultValue(null)]
		public Image Image
		{
			get
			{
				return imageView.Image;
			}
			set
			{
				imageView.Image = value;
			}
		}
	}
}
